#include  "4ru.h"

extern int win_w;


/*  GPR3 change
    GPR3a register  */
int gpr3a(NOTE_NODE *linetop)
{
  NOTE_NODE *cur;
  NOTE_NODE *n[4];
  int pitch_diff12;
  int pitch_diff23;
  int pitch_diff34;

  double pitch_diff12_bias;
  double pitch_diff34_bias;


  cur = linetop;

  while(1){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }
    pitch_diff12_bias = 0.0;
    pitch_diff34_bias = 0.0;

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */

    pitch_diff12 = abs(n[1]->val[NOTE_NO] - n[0]->val[NOTE_NO]);
    pitch_diff23 = abs(n[2]->val[NOTE_NO] - n[1]->val[NOTE_NO]);
    pitch_diff34 = abs(n[3]->val[NOTE_NO] - n[2]->val[NOTE_NO]);

    n[1]->GPR[GPR3a] = (pitch_diff23 - pitch_diff12) + (pitch_diff23 - pitch_diff34);

    if((pitch_diff23 > (pitch_diff12 + pitch_diff12_bias)) &&
       (pitch_diff23 > (pitch_diff34 + pitch_diff34_bias))){
      n[1]->GPR_ON_OFF[GPR3a] = ON;
    }else{
      n[1]->GPR_ON_OFF[GPR3a] = OFF;
    }


    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR3a] = n[1]->GPR[GPR3a];
      n[1]->org_node->GPR_ON_OFF[GPR3a] = n[1]->GPR_ON_OFF[GPR3a];
    }

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
