/*  Time-stamp: <2004-11-16 16:17:48 >  */
#include  "NOTEfile.h"

#define  DEBUG 0

/*
  T_BEAT, T_MEAN, T_REAL, T_DELTA  Τɤ줫ˡ
  ľ
*/

int note_time_consistency(NOTE_NODE *top, NOTE_HEADER *header_info)
{
  if(top == NULL){
    return  EXIT_SUCCESS;
  }

  switch(header_info->timescale){
  case  T_BEAT:
  case  NO_INFO:
    beat2q_time(top, header_info);
    q_time2real(top, header_info);
    q_time2delta(top, header_info);
    beat2meas(top, header_info);
    break;

  case  T_REAL:
    real2beat(top, header_info);
    beat2q_time(top, header_info);
    q_time2delta(top, header_info);
    beat2meas(top, header_info);
    break;

  case  T_DELTA:
    delta2beat(top, header_info);
    beat2q_time(top, header_info);
    q_time2real(top, header_info);
    beat2meas(top, header_info);
    break;

  case  T_MEAS:
    meas2beat(top, header_info);
    beat2q_time(top, header_info);
    meas2delta(top, header_info);
    q_time2real(top, header_info);
    break;

  default:
    br_printf(2, "%s: %d: header_info  timescale  T_BEAT, T_REAL, T_DELTA, NO_INFO ΤɤǤ⤢ޤ\n",
	      __FILE__, __LINE__);
    break;
  }



#if DEBUG
  {
    NOTE_NODE *cur;
    NOTE_NODE *same;
    
    cur = top;
    while(1){
      if(cur == NULL){   break; }
      same = cur;
      while(1){
	if(same == NULL){  break; }
#if 1
      br_printf(-1, "on_time:  %2d: %lf %lf %lf %07d %lf\n",
		same->ident,
		same->on_time.beat,
		same->on_time.real,
		same->on_time.meas,
		same->on_time.delta,
		same->on_time.q_time
		);
#endif
#if 1
      br_printf(-1, "on_diff:  %2d: %lf %lf %lf %07d %lf\n",
		same->ident,
		same->on_diff.beat,
		same->on_diff.real,
		same->on_diff.meas,
		same->on_diff.delta,
		same->on_diff.q_time
		);
#endif
#if 1
      br_printf(-1, "len:      %2d: %lf %lf %lf %07d %lf\n",
		same->ident,
		same->len.beat,
		same->len.real,
		same->len.meas,
		same->len.delta,
		same->len.q_time
		);
#endif
#if 1
      br_printf(-1, "len_diff: %2d: %lf %lf %lf %07d %lf\n",
		same->ident,
		same->len_diff.beat,
		same->len_diff.real,
		same->len_diff.meas,
		same->len_diff.delta,
		same->len_diff.q_time
		);
#endif

      same = same->samenext;
    }
    
    cur = cur->next;
  }
  }
#endif

  return EXIT_SUCCESS;
}
