#include  "xml2note.h"


xmlNode * part_list_analyze(xmlNode *cur, PART_INFO  part_info[PART_NUM],
			    int *part_num, int inst_num[PART_NUM])
{
  int score_instrument_flag = OFF;

  init_partinfo(part_info);

  for(*part_num = 0; *part_num < PART_NUM; (*part_num)++){
    inst_num[*part_num] = 0;
  }

  *part_num = 0;

  /*  now: cur == "part-list"  */

  cur = cur->children;
  /*  now: cur == ("part-list" ̈̑w)  */

  
  while(cur != NULL){
    if(cur->type == XML_ELEMENT_NODE){
      if(xmlStrcmp(cur->name, (const xmlChar *)"score-part") == 0){	/*  <score-part>  */
	strcpy(part_info[*part_num].id, xmlGetProp(cur, "id"));
#ifdef DEBUG2
	br_printf(4, "%s\n", part_info[*part_num].id);
#endif

	cur = cur->children;	/*  now: cur == ("score-part" ̈̑w)  */
	while(cur != NULL){
	  if(cur->type == XML_ELEMENT_NODE){
	    if(xmlStrcmp(cur->name, (const xmlChar *)"part-name") == 0){	/* <part-name> */
	      strcpy(part_info[*part_num].partname, cur->children->content);
#ifdef DEBUG2
	      br_printf(4, "%s\n", part_info[*part_num].partname);
#endif
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"score-instrument") == 0){/* <score-instrument> */
	      score_instrument_flag = ON;
	      strcpy(part_info[*part_num].inst[inst_num[*part_num]].id, xmlGetProp(cur, "id"));
#ifdef DEBUG2
	      br_printf(4, "%s\n", part_info[*part_num].inst[inst_num[*part_num]].id);
#endif
	      cur = cur->children;  /*  now: cur == ("score-instrument" ̈̑w)  */
	      while(cur != NULL){
		if(cur->type == XML_ELEMENT_NODE){
		  if(xmlStrcmp(cur->name, (const xmlChar *)"instrument-name") == 0){ /* <instrument-name> */
		    strcpy(part_info[*part_num].inst[inst_num[*part_num]].instname, cur->children->content);
#ifdef DEBUG2
		    br_printf(4, "%s\n", part_info[*part_num].inst[inst_num[*part_num]].instname);
#endif
		  }
		}

		if(cur->next == NULL){
		  break;
		}
		cur = cur->next;
	      }
	      cur = cur->parent;  /*  now: cur == ("score-part" ̈̑w)  */
	      inst_num[*part_num] += 1;

	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"midi-instrument") == 0){ /*<midi-instrument>*/
	      cur = cur->children;  /*  now: cur == ("midi-instrument" ̈̑w)  */
	      while(cur != NULL){
		if(xmlStrcmp(cur->name, (const xmlChar *)"midi-channel") == 0){ /*<midi-channel>*/
		  sscanf(cur->children->content, "%d", &(part_info[*part_num].midi_ch));
#ifdef DEBUG2
		  br_printf(4, "ch: [%d] %d\n", *part_num, part_info[*part_num].midi_ch);
#endif
		}else if(xmlStrcmp(cur->name, (const xmlChar *)"midi-program") == 0){ /*<midi-program>*/
		  sscanf(cur->children->content, "%d", &(part_info[*part_num].midi_prg));
#ifdef DEBUG2
		  br_printf(4, "prg: [%d] %d\n", *part_num, part_info[*part_num].midi_prg);
#endif
		}

		if(cur->next == NULL){
		  break;
		}
		cur = cur->next;
	      }
	      cur = cur->parent;  /*  now: cur == ("score-part" ̈̑w)  */
	      
	    }else{
	      br_printf(3, "%s: %d: Skip: part-list: %s(XML line: %d)\n",
			__FILE__, __LINE__, cur->name, xmlGetLineNo(cur));
	    }
	  }
	      
	  if(cur->next == NULL){
	    break;
	  }
	  cur = cur->next;
	}
	
	cur = cur->parent;    /*  now: cur == ("part-list" ̈̑w)  */
	*part_num += 1;
      }
    }

    if(cur->next == NULL){
      break;
    }
    cur = cur->next;
  }


  /*  now: cur == ("part-list" ̈̑w)  */

  cur = cur->parent; /*  now: cur == "part-list"  */
  cur = cur->next;  /*  now: cur == ("score-partwise"  next m[h)  */

  return cur;
}

