#include  "4ru.h"
#include  "gen_para.h"


#define  SMF  7
#define  PLAY  4
#define  VIEW  6
#define  GENCHAN_PARA  4


void usage(int argc, char *argv[])
{
  /*  Warning ΍  */
  argc = argc;

  br_printf(-1, "Usage:\n\n");
  
  br_printf(-1, "Prompt> ");
  br_printf(8, "%s", argv[0]);
  br_printf(-1, "  [");
  br_printf(4, "Option");
  br_printf(-1, "]... ");
  
  br_printf(5, "ScrFile");
  
  br_printf(-1, "  [");
  br_printf(4, "Option");
  br_printf(-1, "]...\n\n");
  
  br_printf(5, "ScrFile");
  br_printf(-1, ": ");
  br_printf(5, "XML file");
  br_printf(-1, " or ");
  br_printf(5, "NOTE format file");
  
  br_printf(-1, "\n\n");
  
  br_printf(4, "Option");
  br_printf(-1, ":\n");
  
  br_printf(2, "-ow");
  br_printf(-1,": overwrite checking. \n\n");
  
  br_printf(7, "-4R");
  br_printf(-1,":  output MusicXML(4R) file. \n");
  
  br_printf(SMF, "-smf");
  br_printf(-1,": output SMF.\n");
  
  br_printf(7, "-notebeat");
  br_printf(-1,": output note format file(TIMESCALE BEAT).\n");
  
  br_printf(7, "-notemeas");
  br_printf(-1,": output note format file(TIMESCALE MEAS).\n");
  
  br_printf(7, "-notereal");
  br_printf(-1,": output note format file(TIMESCALE Real).\n");
  
  br_printf(7, "-arff");
  br_printf(-1,": output arff file(for Weka).\n");
  
  br_printf(-1, "\n");
  
  br_printf(VIEW, "-view");
  br_printf(-1,": view file by piano-roll display.\n");
  
  br_printf(PLAY, "-play");
  br_printf(-1,": play file by output MIDI device.\n");
  
  br_printf(-1, "\n");
  
  
  br_printf(8, "-gm");
  br_printf(-1,": output \"GM System ON\" for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-gs");
  br_printf(-1,": output \"GS Reset\" for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-xg");
  br_printf(-1,": output \"XG System ON\" for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-all1ch");
  br_printf(-1,": output All MIDI event to 1ch for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-ppmode");
  br_printf(-1,": for PianoPlayer playing.\n");
  
  br_printf(8, "-displevel");
  br_printf(-1, " ");
  br_printf(3, "n");
  br_printf(-1,": specify display level ");
  br_printf(3, "n");
  br_printf(-1, " for ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  br_printf(-1, "\tn=2: heavy\n");
  br_printf(-1, "\tn=1: light\n");
  br_printf(-1, "\tn=0(default): very light\n");
  
  br_printf(8, "-outid");
  br_printf(-1, " ");
  br_printf(3, "id");
  br_printf(-1,": specify output note ident ");
  br_printf(3, "id");
  br_printf(-1, " for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-outport");
  br_printf(-1, " ");
  br_printf(3, "n");
  br_printf(-1,": specify MIDI output port number");
  br_printf(-1, " for ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-vel");
  br_printf(-1, " ");
  br_printf(3, "n");
  br_printf(-1,": set default velocity value to ");
  br_printf(-1, " ");
  br_printf(3, "n");
  br_printf(-1, " for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  br_printf(-1, "            ");
  br_printf(-1, "(default is n=%d).\n", DEFAULT_VEL);
  
  br_printf(8, "-on_diff");
  br_printf(-1, " ");
  br_printf(8, "n");
  br_printf(-1,": specify on_diff effect level");
  br_printf(-1, " for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  br_printf(-1, "            ");
  br_printf(-1, "(default is n=1.00).\n");
  
  br_printf(8, "-len_diff");
  br_printf(-1, " ");
  br_printf(8, "n");
  br_printf(-1,": specify on_diff effect level");
  br_printf(-1, " for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  br_printf(-1, "            ");
  br_printf(-1, "(default is n=1.00).\n");
  
  br_printf(8, "-ig_beattime");
  br_printf(-1,": ignore \"BEATTIME\"");
  br_printf(-1, " for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(8, "-ig_bpm");
  br_printf(-1,"     : ignore \"BPM\"");
  br_printf(-1, " for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  
  br_printf(5, "-mechanical");
  br_printf(-1, " : equivalent to specify ");
  br_printf(8, "-vel");
  br_printf(-1, " ");
  br_printf(8, "%d", DEFAULT_VEL);
  br_printf(-1, " ");
  
  br_printf(8, "-on_diff");
  br_printf(-1, " ");
  br_printf(8, "0.0");
  br_printf(-1, " ");
  
  br_printf(8, "-len_diff");
  br_printf(-1, " ");
  br_printf(8, "0.0");
  br_printf(-1, " ");
  
  br_printf(8, "-ig_beattime");
  br_printf(-1, " ");
  br_printf(8, "-ig_bpm");
  br_printf(-1, ".\n");
  
  br_printf(8, "-smfdivi");
  br_printf(-1, " ");
  br_printf(3, "n");
  br_printf(-1,": specify output division for ");
  br_printf(SMF, "-smf");
  br_printf(-1, " and ");
  br_printf(PLAY, "-play");
  br_printf(-1, ".\n");
  br_printf(-1, "            ");
  br_printf(-1, "(default is n=%d).\n", DEFAULT_SMF_DIVI);
  
  br_printf(-1, "\n");
  br_printf(8, "-view_divi");
  br_printf(-1, " ");
  br_printf(-1, "{");
  br_printf(3, "on");
  br_printf(-1, "|");
  br_printf(3, "off");
  br_printf(-1, "}");
  br_printf(-1,": set initial state for deviation infomation display for ");
  br_printf(VIEW, "-view");
  br_printf(-1, ".\n");
  br_printf(-1, "            ");
  br_printf(-1, "(default is ");
  br_printf(3, "on");
  br_printf(-1, ").\n");
  
  br_printf(-1, "\n");
  br_printf(8, "-gpr");
  br_printf(-1, " ");
  br_printf(3, "GroupingXML");
  br_printf(-1, ": specify ");
  br_printf(3, "GroupingXML");
  br_printf(-1, "file.\n");
  
  br_printf(-1, "\n");
  br_printf(8, "-width");
  br_printf(-1, " ");
  br_printf(3, "w");
  br_printf(-1, ": set window width to ");
  br_printf(3, "w");
  br_printf(-1, ".\n");
  
  br_printf(8, "-height");
  br_printf(-1, " ");
  br_printf(3, "h");
  br_printf(-1, ": set window height to ");
  br_printf(3, "h");
  br_printf(-1, ".\n");
  
  br_printf(8, "-ppqbeat");
  br_printf(-1, " ");
  br_printf(3, "p");
  br_printf(-1, ": set ");
  br_printf(3, "p");
  br_printf(-1, " pixel / quater beat.\n");
  
  br_printf(8, "-title");
  br_printf(-1, ": display \"TITLE\" infomation on the window title bar. \n");
  
  br_printf(8, "-title-");
  br_printf(-1, ": Not display \"TITLE\" infomation on the window title bar. \n");
  if(DEFAULT_TITLE_TITLE == ON){
    br_printf(-1, "(default is \"-title\".)\n\n");
  }else{
    br_printf(-1, "(default is \"-title-\".)\n\n");
  }

  br_printf(8, "-performer");
  br_printf(-1, ": display \"PERFORMER\" infomation on the window title bar. \n");

  br_printf(8, "-performer-");
  br_printf(-1, ": Not display \"PERFORMER\" infomation on the window title bar. \n");
  if(DEFAULT_TITLE_TITLE == ON){
    br_printf(-1, "(default is \"-performer\".)\n");
  }else{
    br_printf(-1, "(default is \"-performer-\".)\n");
  }

  
  /*
    -gttm
  */
  
  br_printf(7, "\n");
  br_printf(7, "-thanks");
  br_printf(-1,": display thank you for... \n");
  
  br_printf(-1, "\n");
  br_printf(1, "-debug");
  br_printf(-1,": display debug infomation.. \n");
  
  br_printf(-1, "\n\n");
}


void usage_genchan(void)
{
  br_printf(8, "-genchan");
  br_printf(-1, " ");
  br_printf(GENCHAN_PARA, "g1_apex");
  br_printf(-1, " ");
  br_printf(GENCHAN_PARA, "g2_apex");
  br_printf(-1, " ");
  br_printf(GENCHAN_PARA, "def_vel1");
  br_printf(-1, " ");
  br_printf(GENCHAN_PARA, "def_vel2");
  br_printf(-1, " ");
  br_printf(GENCHAN_PARA, "ls1");
  br_printf(-1, " ");
  br_printf(GENCHAN_PARA, "ls2");
  br_printf(-1, "\n\n");

  br_printf(GENCHAN_PARA, "g1_apex");
  br_printf(-1, ": Default value is %3.2f\n", G1_A);
  br_printf(-1, "\t  ()O[v (s1-a1-e1) R^ Velocity ω̒_ł̔{D\n\n");

  br_printf(GENCHAN_PARA, "g2_apex");
  br_printf(-1, ": Default value is %3.2f\n", G2_A);
  br_printf(-1, "\t  ()O[v (s2-a2-e2) R^ Velocity ω̒_ł̔{D\n\n");

  br_printf(GENCHAN_PARA, "def_vel1");
  br_printf(-1, ": Default value is %d\n", VEL1);
  br_printf(-1, "\t  ȉ VelocityD\n\n");

  br_printf(GENCHAN_PARA, "def_vel2");
  br_printf(-1, ": Default value is %d\n", VEL2);
  br_printf(-1, "\t  ȉ VelocityD\n\n");

  br_printf(GENCHAN_PARA, "ls1");
  br_printf(-1, ": Default value is %3.2f\n", LEN_SHIFT_W);
  br_printf(-1, "\t  <words>ls1</words> Ŏ̉̃^{D\n\n");

  br_printf(GENCHAN_PARA, "ls2");
  br_printf(-1, ": Default value is %3.2f\n", LEN_SHIFT_Y);
  br_printf(-1, "\t  <words>ls2</words> Ŏ̉̃^{D\n\n");

/*   br_printf(GENCHAN_PARA, "group0"); */
/*   br_printf(-1, ": Default value is %d\n", GROUP0); */
/*   br_printf(-1, "\t  group0 velocity amplification (group0 is indicated by \"Dashed slur number=\"1\" )\n\n"); */

/*   br_printf(GENCHAN_PARA, "group1"); */
/*   br_printf(-1, ": Default value is %d\n", GROUP1); */
/*   br_printf(-1, "\t  group1 velocity amplification (group0 is indicated by \"Dashed slur number=\"2\")\n\n"); */

/*   br_printf(GENCHAN_PARA, "len_shift"); */
/*   br_printf(-1, ": Default value is %d\n", LEN_SHIFT_Y); */
/*   br_printf(-1, "\t  len_shift amplification (location is indicated by \"*\")\n\n"); */
}
